# coding: utf-8

"""
    CardPay REST API

    Welcome to the CardPay REST API. The CardPay API uses HTTP verbs and a [REST](https://en.wikipedia.org/wiki/Representational_state_transfer) resources endpoint structure (see more info about REST). Request and response payloads are formatted as JSON. Merchant uses API to create payments, refunds, payouts or recurrings, check or update transaction status and get information about created transactions. In API authentication process based on [OAuth 2.0](https://oauth.net/2/) standard. For recent changes see changelog section.  # noqa: E501

    OpenAPI spec version: 3.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class PayoutRequestEWalletAccount(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "bank_branch": "str",
        "bank_code": "str",
        "bank_name": "str",
        "id": "str",
        "name": "str",
        "type": "str",
    }

    attribute_map = {
        "bank_branch": "bank_branch",
        "bank_code": "bank_code",
        "bank_name": "bank_name",
        "id": "id",
        "name": "name",
        "type": "type",
    }

    def __init__(
        self,
        bank_branch=None,
        bank_code=None,
        bank_name=None,
        id=None,
        name=None,
        type=None,
    ):  # noqa: E501
        """PayoutRequestEWalletAccount - a model defined in Swagger"""  # noqa: E501

        self._bank_branch = None
        self._bank_code = None
        self._bank_name = None
        self._id = None
        self._name = None
        self._type = None
        self.discriminator = None

        if bank_branch is not None:
            self.bank_branch = bank_branch
        if bank_code is not None:
            self.bank_code = bank_code
        if bank_name is not None:
            self.bank_name = bank_name
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if type is not None:
            self.type = type

    @property
    def bank_branch(self):
        """Gets the bank_branch of this PayoutRequestEWalletAccount.  # noqa: E501

        Customer bank branch number (name). Mandatory for 'Latin America' and DIRECTBANKINGNGA methods only. For 'Latin America': <ul><li>required for methods where country = BR, UY</li><li>for UY (Uruguay) is optional if 'payment_method' is `UY113`</li></ul> For DIRECTBANKINGNGA: Customer bank branch number (name), only for Ghana banks (GH******)  # noqa: E501

        :return: The bank_branch of this PayoutRequestEWalletAccount.  # noqa: E501
        :rtype: str
        """
        return self._bank_branch

    @bank_branch.setter
    def bank_branch(self, bank_branch):
        """Sets the bank_branch of this PayoutRequestEWalletAccount.

        Customer bank branch number (name). Mandatory for 'Latin America' and DIRECTBANKINGNGA methods only. For 'Latin America': <ul><li>required for methods where country = BR, UY</li><li>for UY (Uruguay) is optional if 'payment_method' is `UY113`</li></ul> For DIRECTBANKINGNGA: Customer bank branch number (name), only for Ghana banks (GH******)  # noqa: E501

        :param bank_branch: The bank_branch of this PayoutRequestEWalletAccount.  # noqa: E501
        :type: str
        """

        self._bank_branch = bank_branch

    @property
    def bank_code(self):
        """Gets the bank_code of this PayoutRequestEWalletAccount.  # noqa: E501

        Customer bank code For DIRECTBANKINGNGA: Customer bank code (3 digits)  # noqa: E501

        :return: The bank_code of this PayoutRequestEWalletAccount.  # noqa: E501
        :rtype: str
        """
        return self._bank_code

    @bank_code.setter
    def bank_code(self, bank_code):
        """Sets the bank_code of this PayoutRequestEWalletAccount.

        Customer bank code For DIRECTBANKINGNGA: Customer bank code (3 digits)  # noqa: E501

        :param bank_code: The bank_code of this PayoutRequestEWalletAccount.  # noqa: E501
        :type: str
        """

        self._bank_code = bank_code

    @property
    def bank_name(self):
        """Gets the bank_name of this PayoutRequestEWalletAccount.  # noqa: E501

        Customer bank name Customer bank name (string)  # noqa: E501

        :return: The bank_name of this PayoutRequestEWalletAccount.  # noqa: E501
        :rtype: str
        """
        return self._bank_name

    @bank_name.setter
    def bank_name(self, bank_name):
        """Sets the bank_name of this PayoutRequestEWalletAccount.

        Customer bank name Customer bank name (string)  # noqa: E501

        :param bank_name: The bank_name of this PayoutRequestEWalletAccount.  # noqa: E501
        :type: str
        """

        self._bank_name = bank_name

    @property
    def id(self):
        """Gets the id of this PayoutRequestEWalletAccount.  # noqa: E501

        For QIWI: Customer phone number (from 1 to 15 digits) For WEBMONEY: Customer account number For NETELLER: Customer email For 'Latin America': Customer personal identification number For YANDEXMONEY: Customer wallet number, 11 to 16 digits, begins with `410` For AIRTEL, MPESA, MTN, UGANDAMOBILE, VODAFONE and TIGO: phone number linked to Customer's mobile money account. Phone prefix is **required**: AIRTEL - 233 (GHS), 256 (UGX); MTN - 233 (GHS), 256 (UGX); TIGO, VODAFONE - 233; UGANDAMOBILE - 256; MPESA - 254 For DIRECTBANKINGNGA: bank account number For PAYPAL: Customer email, phone or PayPal account number *(mandatory for QIWI, PAYPAL, WEBMONEY, NETELLER, 'Latin America', YANDEXMONEY, AIRTEL, MPESA, MTN, UGANDAMOBILE, VODAFONE, TIGO and DIRECTBANKINGNGA methods only)*  # noqa: E501

        :return: The id of this PayoutRequestEWalletAccount.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PayoutRequestEWalletAccount.

        For QIWI: Customer phone number (from 1 to 15 digits) For WEBMONEY: Customer account number For NETELLER: Customer email For 'Latin America': Customer personal identification number For YANDEXMONEY: Customer wallet number, 11 to 16 digits, begins with `410` For AIRTEL, MPESA, MTN, UGANDAMOBILE, VODAFONE and TIGO: phone number linked to Customer's mobile money account. Phone prefix is **required**: AIRTEL - 233 (GHS), 256 (UGX); MTN - 233 (GHS), 256 (UGX); TIGO, VODAFONE - 233; UGANDAMOBILE - 256; MPESA - 254 For DIRECTBANKINGNGA: bank account number For PAYPAL: Customer email, phone or PayPal account number *(mandatory for QIWI, PAYPAL, WEBMONEY, NETELLER, 'Latin America', YANDEXMONEY, AIRTEL, MPESA, MTN, UGANDAMOBILE, VODAFONE, TIGO and DIRECTBANKINGNGA methods only)*  # noqa: E501

        :param id: The id of this PayoutRequestEWalletAccount.  # noqa: E501
        :type: str
        """
        if id is not None and len(id) > 256:
            raise ValueError(
                "Invalid value for `id`, length must be less than or equal to `256`"
            )  # noqa: E501
        if id is not None and len(id) < 1:
            raise ValueError(
                "Invalid value for `id`, length must be greater than or equal to `1`"
            )  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this PayoutRequestEWalletAccount.  # noqa: E501

        Customer bank account name.  # noqa: E501

        :return: The name of this PayoutRequestEWalletAccount.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PayoutRequestEWalletAccount.

        Customer bank account name.  # noqa: E501

        :param name: The name of this PayoutRequestEWalletAccount.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def type(self):
        """Gets the type of this PayoutRequestEWalletAccount.  # noqa: E501

        Customer account type. Mandatory for 'Latin America' methods only. For 'Latin America': <ul><li>required for methods where country = BR, CL, CO</li><li>for PE (PERU) only `M` value is allowed</li><li>for UY (Uruguay) is required only if 'payment_method' is `UY001`</li></ul>  # noqa: E501

        :return: The type of this PayoutRequestEWalletAccount.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this PayoutRequestEWalletAccount.

        Customer account type. Mandatory for 'Latin America' methods only. For 'Latin America': <ul><li>required for methods where country = BR, CL, CO</li><li>for PE (PERU) only `M` value is allowed</li><li>for UY (Uruguay) is required only if 'payment_method' is `UY001`</li></ul>  # noqa: E501

        :param type: The type of this PayoutRequestEWalletAccount.  # noqa: E501
        :type: str
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                if value is not None:
                    result[attr] = value
        if issubclass(PayoutRequestEWalletAccount, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PayoutRequestEWalletAccount):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
